﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Hotline.Identity.Accounts;
using Hotline.Identity.Roles;
using XF.Domain.Entities;

namespace Hotline.SeedData
{
    public class SysAccountSeedData : ISeedData<Account>
    {
        /// <summary>
        /// 种子数据
        /// </summary>
        /// <returns></returns>
        public IEnumerable<Account> HasData() =>
            new[]
            {
                new Account
                {
                    Id = "08daa5f2-1878-4cfa-8764-1244f0229994",
                    ClientId = "sys",
                    UserName = "sysadmin",
                    Name = "初始系统管理账号",
                    PasswordHash = "AQAAAAEAACcQAAAAEKTgPA/GB2GnCEX+yTgZl878j9M7MOEHxdEgRIMc6xcErRv/oDsMmJBB5zaxcDmXyw==",
                    CreationTime = DateTime.Now
                }
            };
    }

    public class RoleSeedData : ISeedData<Role>
    {
        /// <summary>
        /// 种子数据
        /// </summary>
        /// <returns></returns>
        public IEnumerable<Role> HasData() =>
            new[]
            {
                new Role
                {
                    Id = "08dab1a3-5448-4712-869e-6e2dfd3e0cc6",
                    ClientId = "sys",
                    Name = "sysadmin_role",
                    DisplayName = "系统管理员",
                    Description = "系统管理员",
                    CreationTime = DateTime.Now
                }
            };
    }

    public class AccountRoleSeedData : ISeedData<AccountRole>
    {
        /// <summary>
        /// 种子数据
        /// </summary>
        /// <returns></returns>
        public IEnumerable<AccountRole> HasData() =>
            new[]
            {
                new AccountRole
                {
                    AccountId = "08daa5f2-1878-4cfa-8764-1244f0229994",
                    RoleId = "08dab1a3-5448-4712-869e-6e2dfd3e0cc6",
                }
            };
    }
}
